Loading...
Searching...
No Matches
Http_referer

## Macros

#define | HTTP_REFERER_INIT()
| Initializer for structure http_referer_t.
#define | HTTPTAG_REFERER(x)
| Tag list item for pointer to a Referer header object.
#define | HTTPTAG_REFERER_STR(s)
| Tag list item for string with Referer header value.

## Typedefs

typedef struct http_location_s | http_referer_t
| @HTTP_HEADER http_referer Referer header.

## Enumerations

enum | { http_referer_hash }

## Functions

http_referer_t * | http_referer_init (http_referer_t x[1])
| Initialize a structure http_referer_t.
int | http_is_referer (http_header_t const *header)
| Test if header object is instance of http_referer_t.
http_referer_t * | http_referer_dup (su_home_t *home, http_referer_t const *hdr))
| Duplicate (deep copy) `http_referer_t`.
http_referer_t * | http_referer_copy (su_home_t *home, http_referer_t const *hdr))
| Copy a http_referer_t header structure.
http_referer_t * | http_referer_make (su_home_t *home, char const *s))
| Make a header structure http_referer_t.
http_referer_t * | http_referer_format (su_home_t *home, char const *fmt,...)))
| Make a Referer header from formatting result.

## Variables

msg_hclass_t | http_referer_class []
| Header class for HTTP Referer header.
msg_parse_f | http_referer_d
| Decode (parse) a Referer header.
msg_print_f | http_referer_e
| Encode (print) a Referer header.

## Detailed Description

## Macro Definition Documentation

## HTTP_REFERER_INIT

#define HTTP_REFERER_INIT | ( |  | ) |

Initializer for structure http_referer_t.

A static http_referer_t structure must be initialized with the HTTP_REFERER_INIT() macro. For instance,

http_referer_t http_referer = HTTP_REFERER_INIT;
HTTP_REFERER_INIT
#define HTTP_REFERER_INIT()
Initializer for structure http_referer_t.
Definition http_protos.h:7842
http_referer_t
struct http_location_s http_referer_t
@HTTP_HEADER http_referer Referer header.
Definition http.h:142

## HTTPTAG_REFERER

#define HTTPTAG_REFERER | ( |  | x | ) |

Tag list item for pointer to a Referer header object.

The HTTPTAG_REFERER() macro is used to include a tag item with a pointer to a http_referer_t object in a tag list.

Parameters

  x | pointer to a http_referer_t header structure, or NULL.

## HTTPTAG_REFERER_STR

#define HTTPTAG_REFERER_STR | ( |  | s | ) |

Tag list item for string with Referer header value.

The HTTPTAG_REFERER_STR() macro is used to include a tag item with a string containing value of a http_referer_t header in a tag list.

Parameters

  s | pointer to a string containing http_referer_t value, or NULL.

The HTTPTAG_REFERER_STR string can be converted to a http_referer_t header structure by giving the string s has second argument to function http_referer_make().

## Typedef Documentation

## http_referer_t

typedef struct http_location_s http_referer_t

@HTTP_HEADER http_referer Referer header.

The Referer header is used to redirect the recipient to a referer other than the Request-URI for completion of the request or identification of a new resource. Its syntax is defined in RFC 2616 section 14.30 as follows:

Referer = "Referer" ":" absoluteURI

The structure http_referer_t contains representation of Referer header.

The http_referer_t is defined as follows:

typedef struct http_referer_s
{
msg_common_t loc_common[1];
msg_error_t *loc_next;
url_t loc_url[1];
} http_referer_t;
msg_error_t
struct msg_error_s msg_error_t
msg_common_t
struct msg_common_s msg_common_t
url_t

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
http_referer_hash | Hash of Referer header.

## Function Documentation

## http_is_referer()

int http_is_referer | ( | http_header_t const * | header | ) |

inline

Test if header object is instance of http_referer_t.

The function http_is_referer() returns true (nonzero) if the header class is an instance of Referer header object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function http_is_xreferer() returns true (nonzero) if the header object is an instance of header referer and false (zero) otherwise.

## http_referer_copy()

http_referer_t * http_referer_copy | ( | su_home_t * | home,
|  | http_referer_t const * | hdr )

inline

Copy a http_referer_t header structure.

The function http_referer_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  referer = http_referer_copy(home, http->http_referer);
  http_referer_copy
  http_referer_t * http_referer_copy(su_home_t *home, http_referer_t const *hdr))
  Copy a http_referer_t header structure.
  Definition http_protos.h:8036

Returns
  The function http_referer_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## http_referer_dup()

http_referer_t * http_referer_dup | ( | su_home_t * | home,
|  | http_referer_t const * | hdr )

inline

Duplicate (deep copy) `http_referer_t`.

The function http_referer_dup() duplicates a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  referer = http_referer_dup(home, http->http_referer);
  http_referer_dup
  http_referer_t * http_referer_dup(su_home_t *home, http_referer_t const *hdr))
  Duplicate (deep copy) http_referer_t.
  Definition http_protos.h:8029

Returns
  The function http_referer_dup() returns a pointer to the newly duplicated http_referer_t header structure, or NULL upon an error.

## http_referer_format()

http_referer_t * http_referer_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Referer header from formatting result.

The function http_referer_format() makes a new Referer header object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function is usually implemented as a macro calling msg_header_format().

Returns
  The function http_referer_format() returns a pointer to newly makes header structure, or NULL upon an error.

## http_referer_init()

http_referer_t * http_referer_init | ( | http_referer_t | x[1] | ) |

inline

Initialize a structure http_referer_t.

An http_referer_t structure can be initialized with the http_referer_init() function/macro. For instance,

http_referer_t http_referer;
http_referer_init(&http_referer);
http_referer_init
http_referer_t * http_referer_init(http_referer_t x[1])
Initialize a structure http_referer_t.
Definition http_protos.h:7858

## http_referer_make()

http_referer_t * http_referer_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure http_referer_t.

The function http_referer_make() makes a new http_referer_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function is usually implemented as a macro calling http_header_make().

Returns
  The function http_referer_make() returns a pointer to newly maked http_referer_t header structure, or NULL upon an error.

## Variable Documentation

## http_referer_class

msg_hclass_t http_referer_class[]

extern

Header class for HTTP Referer header.

The header class http_referer_class defines how a HTTP Referer header is parsed and printed. It also contains methods used by HTTP parser and other functions to manipulate the http_referer_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.